/*
**	FILE:			ScribeMain.cpp
**	AUTHOR:			Matthew Allen
**	DATE:			9/6/98
**	DESCRIPTION:	Scribe app entry point
**
**	Copyright (C) 1998, Matthew Allen
**		fret@memecode.com
*/

#include "LgiResEdit.h"

int LgiMain(OsAppArguments &AppArgs)
{
	GApp *a = NEW(GApp("application/x-LgiRes", AppArgs));
	if (a AND
		a->IsOk())
	{
		a->AppWnd = NEW(AppWnd);
		if (a->AppWnd)
		{
			a->AppWnd->Visible(true);
			a->Run();
		}
		DeleteObj(a);
	}

	return 0;
}

