#ifndef GFILTER_UTILS_H
#define GFILTER_UTILS_H

/*
#if defined(_DEBUG) && defined(WIN32)
#define BreakPoint	_asm { int 3 }
#else
#define BreakPoint	LgiAssert(0);
#endif
*/

#define BreakPoint	LgiAssert(0);


#define CALL_TYPE			// __stdcall

#define DynFunc0(ret, func)								\
	ret func()											\
	{													\
		typedef ret (CALL_TYPE *p_##func)();						\
		p_##func p = (p_##func) GetAddress(#func);		\
		if (p)											\
		{												\
			return p();									\
		}												\
		BreakPoint										\
		return 0;										\
	}

#define DynFunc1(ret, func, argtype, argname)			\
	ret func(argtype argname)							\
	{													\
		typedef ret (CALL_TYPE *p_##func)(argtype);				\
		p_##func p = (p_##func) GetAddress(#func);		\
		if (p)											\
		{												\
			return p(argname);							\
		}												\
		BreakPoint										\
		return 0;										\
	}

#define DynFunc2(ret, func, argtype1, argname1, argtype2, argname2) \
	ret func(argtype1 argname1, argtype2 argname2)		\
	{													\
		typedef ret (CALL_TYPE *p_##func)(argtype1, argtype2);	\
		p_##func p = (p_##func) GetAddress(#func);		\
		if (p)											\
		{												\
			return p(argname1, argname2);				\
		}												\
		BreakPoint										\
		return 0;										\
	}

#define DynFunc3(ret, func, argtype1, argname1,			\
							argtype2, argname2,			\
							argtype3, argname3)			\
	ret func(argtype1 argname1,							\
			 argtype2 argname2,							\
			 argtype3 argname3)							\
	{													\
		typedef ret (CALL_TYPE *p_##func)(argtype1,				\
								argtype2,				\
								argtype3);				\
		p_##func p = (p_##func) GetAddress(#func);		\
		if (p)											\
		{												\
			return p(argname1, argname2, argname3);		\
		}												\
		BreakPoint										\
		return 0;										\
	}

#define DynFunc4(ret, func, argtype1, argname1,			\
							argtype2, argname2,			\
							argtype3, argname3,			\
							argtype4, argname4)			\
	ret func(argtype1 argname1,							\
			 argtype2 argname2,							\
			 argtype3 argname3,							\
			 argtype4 argname4)							\
	{													\
		typedef ret (CALL_TYPE *p_##func)(argtype1,				\
								argtype2,				\
								argtype3,				\
								argtype4);				\
		p_##func p = (p_##func) GetAddress(#func);		\
		if (p)											\
		{												\
			return p(argname1, argname2,				\
					 argname3, argname4);				\
		}												\
		BreakPoint										\
		return 0;										\
	}

#define DynFunc5(ret, func, argtype1, argname1,			\
							argtype2, argname2,			\
							argtype3, argname3,			\
							argtype4, argname4,			\
							argtype5, argname5)			\
	ret func(argtype1 argname1,							\
			 argtype2 argname2,							\
			 argtype3 argname3,							\
			 argtype4 argname4,							\
			 argtype5 argname5)							\
	{													\
		typedef ret (CALL_TYPE *p_##func)(argtype1,				\
								argtype2,				\
								argtype3,				\
								argtype4,				\
								argtype5);				\
		p_##func p = (p_##func) GetAddress(#func);		\
		if (p)											\
		{												\
			return p(argname1, argname2,				\
					 argname3, argname4,				\
					 argname5);							\
		}												\
		BreakPoint										\
		return 0;										\
	}

#define DynFunc6(ret, func, argtype1, argname1,			\
							argtype2, argname2,			\
							argtype3, argname3,			\
							argtype4, argname4,			\
							argtype5, argname5,			\
							argtype6, argname6)			\
	ret func(argtype1 argname1,							\
			 argtype2 argname2,							\
			 argtype3 argname3,							\
			 argtype4 argname4,							\
			 argtype5 argname5,							\
			 argtype6 argname6)							\
	{													\
		typedef ret (CALL_TYPE *p_##func)(argtype1,		\
								argtype2,				\
								argtype3,				\
								argtype4,				\
								argtype5,				\
								argtype6);				\
		p_##func p = (p_##func) GetAddress(#func);		\
		if (p)											\
		{												\
			return p(argname1, argname2,				\
					 argname3, argname4,				\
					 argname5, argname6);				\
		}												\
		BreakPoint										\
		return 0;										\
	}


#endif
