/// \file
/// \author Matthew Allen
/// \brief A tab control that resizes to it's parent client area.

#ifndef __GTAB_VIEW
#define __GTAB_VIEW

#include "Lgi.h"
#include "GTabView.h"

class LgiClass GTabLayout : public GTabView
{
	bool Edge;

public:
	GTabLayout();
	~GTabLayout();
	
	// Props
	bool Border();
	void Border(bool b);
	
	// View
	bool Pour(GRegion &r);

	// Events
	void OnPosChange();
};

#endif
