
#ifndef __QFontMetrics_h
#define __QFontMetrics_h

#include "qfont.h"

class QFontMetrics : public QObject
{
	class QFontMetricsPrivate *Data;

public:
	QFontMetrics(QFont *f);
	~QFontMetrics();

	int width(uchar i);
	int width(char *str, int len = -1);
	int width(char16 *str, int len = -1);
	int height();
	int ascent();
	int descent();
	
	uchar *GetCoverage(uchar *Map, int Max);
};

#endif
