/**
	\file
	\author Matthew Allen
*/

#ifndef _GPRINTER_H_
#define _GPRINTER_H_

/// Class to connect to a printer and start printing pages.
class LgiClass GPrinter
{
	class GPrinterPrivate *d;

public:
	GPrinter();
	virtual ~GPrinter();

	/// Start a print job
	GPrintDC *StartDC(char *PrintJobName, GView *Parent = 0);

	/// Browse to a printer
	bool Browse(GView *Parent);
	
	/// Write the user selected printer to a string for storage
	bool Serialize(char *&Str, bool Write);
};

#endif
