#ifndef _GPROCESS_H_
#define _GPROCESS_H_

#include "GStream.h"

LgiFunc bool LgiIsProcess(OsProcessId Pid);

class LgiClass GProcess
{
	class GProcessPrivate *d;

public:
	GProcess();
	~GProcess();
	
	OsProcess Handle(); // Pid
	int ExitValue();
	bool Terminate();
	bool Run(char *Exe, char *Args, char *Dir, bool Wait, GStream *In = 0, GStream *Out = 0);
	bool IsRunning();
};

#endif
