
#ifndef _GWORDSTORE_H_
#define _GWORDSTORE_H_

class GWordStore
{
	char *File;
	GHashTable Table;
	bool Dirty;
	int Items;

public:
	GWordStore(char *file = 0);
	~GWordStore();
	
	// Serialization
	bool Serialize(char *file, bool Load);
	
	// Container
	int GetItems();
	void SetItems(int s);
	bool Insert(char *Word);
	int GetWordCount(char *Word);
	void Empty();
	char *GetFile() { return File; }

	#ifdef _DEBUG
	int64 Sizeof();
	#endif
};

#endif
