
#ifndef __QEvent_h
#define __QEvent_h

#include "LgiLinux.h"

#define DOUBLE_CLICK_TIME	400

class QEvent : public QObject
{
protected:
	XEvent *Event;
	char16 Char;

public:
	QEvent(XEvent *e, QInput *i = 0);

	XEvent *GetEvent() { return Event; }

	// General
	int type();

	// Mouse
	int x();
	int y();
	int button();
	bool down();
	bool doubleclick();

	int ScreenX();
	int ScreenY();
	
	// Keyboard
	int ascii();
	int state();

	// Wheel
	int delta();

	// Focus
	bool focus();

	// Expose
	GRect &exposed();
};

#endif
