
#ifndef __QFont_h
#define __QFont_h

#define Status int
#include "Xft.h"
#undef Status
#include "LgiLinux.h"
#include "qpainter.h"

class QFont : public QObject
{
	class QFontPrivate *Data;
	friend class QFontMetrics;

	void GetScale(double &x, double &y);

public:
	QFont();
	~QFont();

	Font GetFont();
	XFontStruct *GetStruct();
	XftFont *GetTtf();
	QFont &operator =(QFont &f);

	void SetPainter(QPainter *p);
	void SetFamily(char *face);
	void SetPointSize(int height);
	void SetBold(bool bold);
	void SetItalic(bool italic);
	void SetUnderline(bool underline);

	int GetAscent();
	int GetDescent();
	char *GetFamily();
	int GetPointSize();
	bool GetBold();
	bool GetItalic();
	bool GetUnderline();
};

#endif
