
#ifndef __QImage_h
#define __QImage_h

#include "LgiLinux.h"

class QImage : public QObject
{
	friend class QPainter;
	
	XImage *Img;
	int Bits;

public:
	enum BlitOp
	{
		ColorOnly
	};

	QImage();
	~QImage();
	
	XImage *GetImage() { return Img; }
	
	bool create(int x, int y, int bits);
	uchar *scanLine(int y);
	int bytesPerLine();
	int getBits();
};

typedef QImage						*OsBitmap;


#endif
