
#ifndef __QWindowMain_h
#define __QWindowMain_h

#include "LgiLinux.h"
#include "qwidget.h"
#include "qmenubar.h"

class QMainWindow : public QWidget
{
	friend class QApplication;
	class QMainWindowPrivate *d;
	
public:
	QMainWindow();
	~QMainWindow();

	// QMenuBar *menuBar();
	bool GetIgnoreInput();
	void SetIgnoreInput(bool i);
	bool Modal();
	void Modal(QMainWindow *Owner);
	QWidget *GetLastFocus();
	void SetLastFocus(QWidget *w);
	void DefaultFocus();
};

#endif
