#include "Lgi.h"

///////////////////////////////////////////////////////////////////////////
OsApplication::OsApplication(int args, char **arg)
{
	Y::Y::initialise(&args, &arg);
}

void OsApplication::Run()
{
	Y::Y::run();
}

///////////////////////////////////////////////////////////////////////////
class YViewPrivate
{
public:
	GView *v;
	Y::Widget *w;
	bool DeleteMe;
	YView *Parent;
	
	YViewPrivate()
	{
		v = 0;
		w = 0;
		Parent = 0;
		DeleteMe = 0;
	}
};

YView::YView(GView *v, bool p)
{
	d = NEW(YViewPrivate);
	d->v = v;
}

YView::~YView()
{
	if (d->v)
	{
		d->v->_View = 0;
	}
	
	DeleteObj(d);
}

void YView::SetHandle(Y::Widget *p)
{
	d->w = p;
}

GView *YView::_GetWndPtr()
{
	return d->v;
}

void YView::_SetWndPtr(GView *v)
{
	d->v = v;
}

void YView::_SetDeleteMe()
{
	d->DeleteMe = true;
}

Y::Widget *YView::handle()
{
	return d->w;
}

YView *YView::parentWidget()
{
	return d->Parent;
}

bool YView::reparent(void *Parent, OsPoint &p, bool vis)
{
	return 0;
}

bool YView::isTabStop()
{
	return 0;
}

void YView::isTabStop(bool i)
{
}

GRect &YView::geometry()
{
	GRect r;
	return r;
}

void YView::setGeometry(int x, int y, int w, int h)
{
}

void YView::repaint()
{
}

void YView::repaint(int x, int y, int w, int h)
{
}

void YView::update()
{
}

void YView::update(int x, int y, int w, int h)
{
}

void YView::setText(char *s)
{
	if (d->w)
	{
		d->w->setProperty ("title", s);
	}
}

bool YView::isEnabled()
{
	return 0;
}

void YView::setEnabled(bool b)
{
}

void YView::show()
{
}

void YView::hide()
{
}

void YView::setFocus()
{
}

void YView::clearFocus()
{
}

bool YView::hasFocus()
{
	return 0;
}

void YView::grabMouse()
{
}

void YView::ungrabMouse()
{
}

OsPoint &YView::mapToGlobal(OsPoint &p)
{
	return p;
}

OsPoint &YView::mapFromGlobal(OsPoint &p)
{
	return p;
}

int YView::wantKeys()
{
	return 0;
}

void YView::wantKeys(int w)
{
}

///////////////////////////////////////////////////////////////////////////
void YPainter::SetClient(GRect *r)
{
}

///////////////////////////////////////////////////////////////////////////
int YFont::GetAscent()
{
}
